package twentyonecoders.GUI.components;

import javafx.scene.control.Button;
import javafx.scene.image.Image;
import javafx.scene.layout.*;

import twentyonecoders.Controller;
import twentyonecoders.logic.Config;
import twentyonecoders.logic.Player;

/**
 * @author Marco Sciacovelli
 */
public class Chip extends Button {

    /**
     * Creates a chip and calls the bet method with the passed value
     * and according to to the passed player.
     * @param value of the chip.
     * @param player that pressed the chip.
     * @param controller that controls the flow of the game.
     */
    public Chip(int value, Player player, Controller controller) {
        this.setMinWidth(50);
        this.setMinHeight(50);
        this.setBackground(
                new Background(
                        new BackgroundImage(
                                new Image(String.valueOf(this.getClass().getResource("/Images/" + value + "_chip.png"))),
                                BackgroundRepeat.NO_REPEAT,
                                BackgroundRepeat.NO_REPEAT,
                                BackgroundPosition.CENTER,
                                new BackgroundSize(1.0, 1.0, true, true, false, false)
                        )
                )
        );
        this.setStyle("-fx-effect: dropshadow(three-pass-box, rgba(0,0,0,0.25), 10, 0, 4, 4)");
        this.setOnMouseClicked(event -> controller.bet(player, value));
    }
}
