package twentyonecoders.utils;

import twentyonecoders.logic.Player;

import java.io.FileWriter;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;

/**
 * @author Marco Sciacovelli
 */
public class LogUtil {

    /**
     * Writes a line to the log file containing date, player and log message.
     * @param player that caused log.
     * @param message to be written.
     */
    public void log(Player player, String message) {
        try {
            Path path = Path.of("logs.csv");
            DateTimeFormatter dtf = DateTimeFormatter.ofPattern("yyyy/MM/dd HH:mm:ss");
            LocalDateTime now = LocalDateTime.now();
            if(!Files.exists(path)) {
                Files.createFile(path);
            }
            if(player == null) {
                Files.writeString(path, Files.readString(path) + dtf.format(now) + "," + null + "," + message + "\n");
            } else {
                Files.writeString(path, Files.readString(path) + dtf.format(now) + "," + player.getName() + "," + message + "\n");
            }
        } catch (IOException e) {
            System.out.println(e.getMessage());
        }
    }
}
