package twentyonecoders.logic;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import twentyonecoders.logic.Card;

import static org.junit.jupiter.api.Assertions.assertEquals;
import java.util.ArrayList;

public class HandTest {

    private ArrayList<Card> cardStates;

    @BeforeEach
    public void setUp() {
        cardStates = new ArrayList<Card>();
    }

    @Test
    void shouldCreateHandWithAceAsEleven() {
        Hand hand = new Hand(cardStates);
        hand.addCard(new Card(Card.Suit.HEARTS, Card.Rank.ACE));
        hand.addCard(new Card(Card.Suit.DIAMONDS, Card.Rank.FOUR));
        assertEquals(hand.getValue(), 15);
    }

    @Test
    void shouldCreateHandWithAceAsOne() {
        Hand hand = new Hand(cardStates);
        hand.addCard(new Card(Card.Suit.HEARTS, Card.Rank.ACE));
        hand.addCard(new Card(Card.Suit.DIAMONDS, Card.Rank.FOUR));
        hand.addCard(new Card(Card.Suit.HEARTS, Card.Rank.ACE));
        hand.addCard(new Card(Card.Suit.HEARTS, Card.Rank.TWO));
        assertEquals(hand.getValue(), 18);
    }

    @Test
    void shouldResetHand() {
        Hand hand = new Hand(cardStates);
        hand.addCard(new Card(Card.Suit.HEARTS, Card.Rank.ACE));
        hand.addCard(new Card(Card.Suit.DIAMONDS, Card.Rank.FOUR));
        hand.addCard(new Card(Card.Suit.HEARTS, Card.Rank.ACE));
        hand.addCard(new Card(Card.Suit.HEARTS, Card.Rank.TWO));
        hand.resetHand();
        assertEquals(hand.getValue(), 0);
    }

    @Test
    void shoudlGetCards() {
        Hand hand = new Hand(cardStates);
        hand.addCard(new Card(Card.Suit.HEARTS, Card.Rank.ACE));
        cardStates.add(new Card(Card.Suit.HEARTS, Card.Rank.ACE));
        hand.addCard(new Card(Card.Suit.DIAMONDS, Card.Rank.FOUR));
        cardStates.add(new Card(Card.Suit.DIAMONDS, Card.Rank.FOUR));
        hand.addCard(new Card(Card.Suit.HEARTS, Card.Rank.ACE));
        cardStates.add(new Card(Card.Suit.HEARTS, Card.Rank.ACE));
        hand.addCard(new Card(Card.Suit.HEARTS, Card.Rank.TWO));
        cardStates.add(new Card(Card.Suit.HEARTS, Card.Rank.TWO));
        assertEquals(hand.getCards(), cardStates);
    }
}
