package twentyonecoders.logic;

import org.junit.jupiter.api.Test;
import static org.junit.jupiter.api.Assertions.assertEquals;
import java.util.ArrayList;

public class PlayerTest {

    @Test
    void shouldCreatePLayerWithHand() {
        Hand hand = new Hand(new ArrayList<>());
        hand.addCard(new Card(Card.Suit.DIAMONDS, Card.Rank.EIGHT));
        hand.addCard(new Card(Card.Suit.SPADES, Card.Rank.QUEEN));
        Player player = new Player("Test", 0);
        player.setHand(hand);
        assertEquals(player.getHand(), hand);
        assertEquals(player.getHand().getValue(), 18);
        assertEquals(player.getName(), "Test");
        assertEquals(player.getMoney(), 0);
    }

    @Test
    void shouldAddMoney() {
        Player player = new Player("Test", 10);
        player.setMoney(player.getMoney() + 10);
        assertEquals(player.getMoney(), 20);
    }

    @Test
    void shouldChangeCurrentBet() {
        Player player = new Player("Test", 10);
        player.setCurrentBet(10);
        player.setCurrentBet(20);
        assertEquals(player.getCurrentBet(), 30);
    }
}
